UNIT Segment;{Realm of Lore v1.44}
{$N+}{$E+}{$S+}{F+}{X+}

interface
uses dos,crt,ddplus;
{--------------------------------------------------------------------------}
type player_info = record
   names: string[20]; {player handle in the game}
   real_names: string[50] {real name/or handle from BBS} ;
   hit_points  {player hit points}
  ,bad  {don't know - might not be used at all}
  ,rate: integer; {again, couldn't find this one in the source}
  hit_max: integer; {hit_point max}
  weapon_num: integer; {weapon number}
  weapon: string[20]; {name of weapon}
  seen_master: integer; {equals 5 if seen master, else 0}
  fights_left: integer; {forest fights left}
  human_left: integer; {human fights left}
  gold: longint; {gold in hand}
  bank: longint; {gold in bank}
  def: integer;  {total defense points }
  strength: integer; {total strength}
  charm: integer; {good looking meter}
  seen_dragon: integer; {seen dragon?  5 if yes else 0}
  seen_violet: integer; {seen violet?  5 if yes else 0}
  level: integer; {level of player}
  time: word; {day # that player last played on}
  arm: string[20]; {armour name}
  arm_num: integer; {armour number}
  dead: shortint; {player dead?  5 if yes else 0}
  inn: shortint; {player sleeping at inn?  5 if yes else 0}
  gem: integer; {# of gems on hand}
  exp: longint; {experience}
  sex: shortint; {gender, 5 if female else 0}
  seen_bard: shortint; {seen bard?  5 if yes else 0}
  last_alive_time: integer; {day # player was last reincarnated on}
  Lays: integer; {players lays stat}
  Why: integer; {not used yet}
  on_now: boolean; {is player on?}
  m_time: integer; {day on_now stat was last used}
  time_on: string[5]; {time player logged on in Hour:Minutes format}
  class: shortint; {class, should be 1, 2 or 3}
  extra: integer;      {*NEW*  If 1, player has a horse}
  love: string[25]; {not used - may be used for inter-player marrages later}
  married: integer; {who player is married to, should be -1 if not married}
  kids: integer; {# of kids}
  king: integer; {# of times player has won game}
  skillw: shortint; {number of Death Knight skill points}
  skillm: shortint; {number of Mystical Skills points}
  skillt: shortint; {number of Thieving Skills points}
  levelw: shortint; {number of Death Knight skill uses left today}
  levelm: shortint; {number of Mystical skill uses left today}
  levelt: shortint; {number of Thieving skill uses left today}
  inn_random: boolean; {not used yet}
  married_to: integer; {same as Married, I think - don't know why it's here}
  v1: longint;
  v2: integer; {# of player kills}
  v3: integer; {if 5, 'wierd' event in forest will happen}
  v4: boolean; {has player done 'special' for that day?}
  v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;  {Warning: Joseph's NPCLORD screws with all three}
  end;
{--------------------------------------------------------------------------}
  type ROL_player = Record {}
           Player_Real:String[50];{Player's REAL NAME!}
           Player_name:string[20];{Player's Character Name}
           Fights_left:integer;   {number of fights remaining in the realm}
           Enemy_Kills:Byte;      {How many kills today}
           Next_Time  :Word;      {Day # of next gameplay(will revive stats)}
           Potions    :integer;   {Number of healing potions}
           Dead       :boolean;   {Did player Die last game?}
           Camp       :boolean;   {Is player camping in a Realm?}
           man_fight  :boolean;   {did player fight the oldman?}
           camp_attack:boolean;   {was player attacked in the camp?}
           who_Attack :string[20];{who attacked!}
           camp_dead  :Boolean;   {Did player win or lose fight?}
           TGold      :Longint;   {Gold in Treasury}
           TGems      :Integer;   {Gems in Treasury}
  end;
{--------------------------------------------------------------------------}
 type monst = record
           name: string[60];
           strength: longint;
           gold: longint;
           weapon: string[60];
           exp_points: longint;
           hit_points: longint;
           death: string[100]; {shown when monster is killed by power move}
  end;
{--------------------------------------------------------------------------}
 type old_man = record
           gold: longint;
           Gems: Longint;
            end;
{--------------------------------------------------------------------------}
type camper_list = record
                 recno: byte;
                 name : string[20];
                 exp  : longint;
                 level: integer;
                 class: shortint;
                 end;
{--------------------------------------------------------------------------}

VAR
   site,client:string;
   kcf,kcl,kcb,fkey:longint;Fakey:String;
   regF,REGL,REGB,REGK:STRING;
   regcode   :string;
   execode:longint;
   da:boolean;
   FN:PATHSTR;
   who               :byte;
   Camp_attack,
   abort_camp_fight  :boolean;
   Old_name          :string[20]; {Player's name before they changed}
   Name_change,                   {Did the player change their name in lord?}
   cheat,GoAhead     :Boolean;
   OpenAttempts      :word;

   crcval            :longint;
   oldman_fought,
   in_camp,shot_gun  :Boolean;
   Shot_gun_shells   :shortint;

   dummy             :char;

   Monster_file      : File of Monst;
   Monst_Rec         : array[1..11] of Monst;{ MONST,LEVEL }

   Oldman_file       : File of old_man;
   oldman_rec        : old_man;

   Monst_Name        :String[60];
   Monst_Str         :Longint;
   Monst_Gold        :LongInt;
   Monst_Weapon      :String[60];
   Monst_EXP         :Longint;
   Monst_HP          :longint;
   Monst_Death       :String[100];
   Monst_HM          :longint; {Monst hit max}


   Player_Data_File  :FILE OF Player_Info;
   Player_Rec        :Player_info;
   Camper_rec        :player_info;
   camper            :array[1..150] of camper_list;
   NumCamp           :byte;

   Rol_PDat_file     :File of Rol_player;
   Player_Now        :Rol_player;
   rol_camper        :rol_player;
   at                :string[80];
   Realm_Name        :String[8];
   REALM             :byte;
   ByteVar,
   level             :byte;
   dumnum,i          :integer;

   power_death       :String;
   PowerPT           :Real;

   find              :word;
   ILEVEL            :LONGINT;
   Power,
   registered,
   JBP,Just_Bought,
   Just_start        :boolean;
{--------------------------------------------------------------------------}
procedure Morecheck;
procedure Treasury;
procedure Swrite_color(st:string);
Procedure Display_Char_Stats;
{--------------------------------------------------------------------------}

implementation

{--------------------------------------------------------------------------}
Procedure Swrite_Color(st:string);
var PLACE:byte;code:string;fc,bc:byte;
begin
fc:=current_foreground;bc:=current_background;
for PLACE:= 1 to length(st) do
 begin
  IF (Copy(ST,place,1))='`' then begin
     delete(st,place,1);
     code:=(copy(st,place,1));

      if code='1' then begin
      delete(st,place,1);
      set_color(1,0);
      end;
      if code='2' then begin
      delete(st,place,1);
      set_color(2,0);
      end;
      if code='3' then begin
      delete(st,place,1);
      set_color(3,0);
      end;
      if code='4' then begin
      delete(st,place,1);
      set_color(4,0);
      end;
      if code='5' then begin
      delete(st,place,1);
      set_color(5,0);
      end;
      if code='6' then begin
      delete(st,place,1);
      set_color(6,0);
      end;
      if code='7' then begin
      delete(st,place,1);
      set_color(7,0);
      end;
      if code='8' then begin
      delete(st,place,1);
      set_color(8,0);
      end;
      if code='9' then begin
      delete(st,place,1);
      set_color(9,0);
      end;
      if code='0' then begin
      delete(st,place,1);
      set_color(10,0);
      end;
      if code='!' then begin
      delete(st,place,1);
      set_color(11,0);
      end;
      if code='@' then begin
      delete(st,place,1);
      set_color(12,0);
      end;
      if code='#' then begin
      delete(st,place,1);
      set_color(13,0);
      end;
      if code='$' then begin
      delete(st,place,1);
      set_color(14,0);
      end;
      if code='%' then begin
      delete(st,place,1);
      set_color(15,0);
      end;
      if code='*' then begin
      delete(st,place,1);
      swriteln('');
      end;

  end;
  IF (Copy(ST,place,1))='~' then begin
     delete(st,place,1);
     code:=(copy(st,place,1));

      if code='1' then begin
      delete(st,place,1);
      set_color(17,0);
      end;
      if code='2' then begin
      delete(st,place,1);
      set_color(18,0);
      end;
      if code='3' then begin
      delete(st,place,1);
      set_color(19,0);
      end;
      if code='4' then begin
      delete(st,place,1);
      set_color(20,0);
      end;
      if code='5' then begin
      delete(st,place,1);
      set_color(21,0);
      end;
      if code='6' then begin
      delete(st,place,1);
      set_color(22,0);
      end;
      if code='7' then begin
      delete(st,place,1);
      set_color(23,0);
      end;
      if code='8' then begin
      delete(st,place,1);
      set_color(24,0);
      end;
      if code='9' then begin
      delete(st,place,1);
      set_color(25,0);
      end;
      if code='0' then begin
      delete(st,place,1);
      set_color(26,0);
      end;
      if code='!' then begin
      delete(st,place,1);
      set_color(27,0);
      end;
      if code='@' then begin
      delete(st,place,1);
      set_color(28,0);
      end;
      if code='#' then begin
      delete(st,place,1);
      set_color(29,0);
      end;
      if code='$' then begin
      delete(st,place,1);
      set_color(30,0);
      end;
      if code='%' then begin
      delete(st,place,1);
      set_color(31,0);
      end;
  end;
 swrite(copy(st,place,1));
 end;
set_color(fc,bc);
end;


{--------------------------------------------------------------------------}
procedure morecheck;
var
 ch: char;
begin;
 swrite_color('`8[`%MORE`8]');
 sread_char(ch);
 swrite(#8+#8+#8+#8+#8+#8);
 write('      ');
 write(#8+#8+#8+#8+#8+#8);
  gettime(t1_h,t1_m,t1_s,t1_jnk);
  gettime(t2_h,t2_m,t2_s,t2_jnk);
end;
{--------------------------------------------------------------------------}

Procedure Display_Char_Stats;
var a:char;loopy:byte;
begin
sclrscr;
set_color(10,0);
for loopy:=1 to ((60-(length(Player_rec.names)+18))div 2) do
begin
swrite('');
end;
loopy:=0;
swrite(' ');
set_color(15,0);swrite_color(Player_rec.names);Swrite('''s Information');
set_color(10,0);swrite(' ');
for loopy:=1 to ((60-(length(Player_rec.names)+18))div 2) do
begin
swrite('');
end;
swriteln('');
loopy:=0;

swrite_color('`2Experience       `7: `%'+inttostr(Player_rec.exp));swriteln('');
swrite_color('`2Level            `7: `%'+IntToSTR(Player_rec.level));swriteln('');
swrite_color('`2Gold In Hand     `7: `%'+inttostr(Player_rec.gold));swriteln('');
swrite_color('`2Weapon           `7: `%'+Player_rec.weapon);swriteln('');
swrite_color('`2Armor            `7: `%'+Player_rec.arm);swriteln('');
swrite_color('`2Hit Points       `7: `%'+inttostr(Player_rec.hit_points));
swrite_color(' `2of `%'+(IntToSTR(Player_rec.hit_max)));swriteln('');
swrite_color('`2Attack Strength  `7: `%'+IntToSTR(Player_rec.strength));swriteln('');
swrite_color('`2Defense Strength `7: `%'+IntToSTR(Player_rec.def));swriteln('');
swrite_color('`2Number of Gems   `7: `%'+intToSTR(Player_rec.gem));swriteln('');
swrite_color('`2Number of Potions`7: `%'+inttostr(Player_now.potions));swriteln('');
swrite_color('`2Realm Fights Left`7: `%'+inttostr(player_now.fights_left));swriteln('');
swrite_color(' `0`*');
swrite_color('`2Gold in Treasury: ');set_color(15,0);
if player_now.tgold>0 then swriteln(inttostr(player_now.tgold))
   else swriteln('NONE');
swrite_color('`2Gems in Treasury: ');set_color(15,0);
if player_now.tgEMS>0 then swriteln(inttostr(player_now.tgEMS))
   else swriteln('NONE');
swrite_color(' `0`*');
if player_rec.Class=1 then begin
swrite_color('`2Current Class Interest  `7: `%Death Knight');swriteln('');
swrite_color('`2Death Knight Skill Level`7: `%'+IntToSTR(Player_rec.skillw));swriteln('');
swrite_color('`2Power Pellets Remaining `7: `%'+IntToSTR(Player_rec.levelw));swriteln('');
end;

if player_rec.Class=2 then begin
swrite_color('`2Current Class Interest  `7: `%Mystic');swriteln('');
swrite_color('`2Mystic Skill Level      `7: `%'+IntToSTR(Player_rec.skillm));swriteln('');
swrite_color('`2Power Pellets Remaining `7: `%'+IntToSTR(Player_rec.levelm));swriteln('');
end;

if player_rec.Class=3 then begin
swrite_color('`2Current Class Interest  `7: `%Thief');swriteln('');
swrite_color('`2Thief Skill Level       `7: `%'+IntToSTR(Player_rec.skillt));swriteln('');
swrite_color('`2Power Pellets Remaining `7: `%'+IntToSTR(Player_rec.levelt));swriteln('');
end;
swrite_color(' `0 ');swriteln('');
if registered=true then begin
swrite_color('`2Camp Raids Remaining    `7: `%'+IntToSTR(Player_rec.human_left));swriteln('');
end;
swrite_color('`2Time Remaining in Realm `7: `%'+inttostr(time_left)+' `2Minutes');swriteln('');
if shot_gun=true then begin
swrite_color('`$You have the Shotgun with `%'+inttostr(Shot_gun_shells)+' `$shells remaining.');swriteln('');

end;{shotgun}
set_color(10,0);swriteln('');

morecheck;
End;

{--------------------------------------------------------------------------}

Procedure Treasury;
var dw,gg:char;amount:longint;dchk:byte;
begin
{MENU}
dchk:=0;
repeat
swriteln('');swriteln('');
Set_Color(2,0);swrite(  '');
Set_Color(10,0);swrite('[');
Set_Color(15,0);swrite('Treasury');
Set_Color(10,0);swrite(']');
Set_Color(2,0);swriteln('');
swrite_color('`0[`%D`0]`7eposit`*');
swrite_color('`0[`%W`0]`7ithdraw`*');
swrite_color('`0[`%T`0]`7ransfer Gold`*');
swrite_color('`0[`%V`0]`7iew Stats`*');
swrite_color('`2[`7Q`2]`7uit`*');
Set_Color(2,0);swriteln('');
set_color(15,0);Swrite('Option');
set_color(7,0) ;swrite(':> ');

     repeat sread_char(dw);dw:=upcase(dw);until dw in ['T','D','W','V','Q',#3,#13,'?'];

       if dw in [#13,#3] then sclrscr;
       if dw='?' then swrite_color('`!Display Menu `*');

       if dw='V' then Display_char_stats;

       if dw='Q' then swrite_color('`7Quit `*');

       if dw='D' then
       begin
           swrite_color('`!Deposit`*');swriteln('');
          Swrite_Color('`0`*');
          swrite_color('`0`$$`0`%Gold `*');
          swrite_color('`0`5*`0`%Gems `*');
          Swrite_Color('`0`*');
          swrite_color('`7[`%Option`7]`8:> `!');
          repeat sread_char(gg);until gg in ['$','*',#13,#3];

           if gg='$' then
           begin
              swrite_color('`$GOLD`*');swriteln('');

              if (player_rec.gold<1) then
              begin
                 swrite_color('`$You have no gold to transfer!`*');
                 exit;
              end;


              if (player_rec.gold>0) then
              begin
                 swrite_color('`0You are carrying `$'+inttostr(player_rec.gold)+' `0Gold Coins`*');
                 swrite_color('`0How much gold do you want to leave`2?`*');
                 swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
                 sread_num_longint(amount);

                 if (amount>player_rec.gold) then
                  begin
                    swriteln('');
                    swrite_color('`$You do not have that much gold!`7 `*');
                  end;

                 if (amount<1) then swrite_color('`7Okay, nevermind then.`*');

                 if (amount+player_now.tgold>2147483646) then begin
                 swriteln('');
                 swrite_color('`$Sorry your treasury deposit box can not hold any more gold!`*');
                 exit;end;

                 if (amount=1) and (amount+player_now.tgold<2147483647) then
                 begin
                    swriteln('');
                    swrite_color('`7The Old Man takes `$'+inttostr(player_rec.gold)+' `7Gold coins for safe keeping...`*');
                    player_now.tgold:=player_now.tgold+player_rec.gold;
                    oldman_rec.gold:=oldman_rec.gold+player_rec.gold;
                    player_rec.gold:=0;
                 end;{transfer good}

                 if (amount<=player_rec.gold) and (amount>1) then
                 begin
                    player_now.tgold:=player_now.tgold+amount;
                    oldman_rec.gold:=oldman_rec.gold+amount;
                    player_rec.gold:=player_rec.gold-amount;
                    swriteln('');
                    swrite_color('`7The Old Man takes `$'+inttostr(amount)+' `7Gold coins for safe keeping...`*');
                 end;{transfer good}

              end;{has gold}
          end;{gold choice}


           if gg='*' then
           begin
              swrite_color('`5GEMS`*');swriteln('');

              if (player_rec.gem<1) then
              begin
                 swrite_color('`$You have no gems to transfer!`*');
                 exit;
              end;

              swrite_color('`0You are carrying `5'+inttostr(player_rec.gem)+' `0Gems`*');
              swrite_color('`0How many gems do you want to leave`2?`*');
              swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
              sread_num_longint(amount);

                if (amount>player_rec.gem) then begin swriteln('');swrite_color('`$You do not have that many gems!`7 `*');end;

                if (amount<1) then swrite_color('`7Okay, nevermind then.`*');

                if (amount+player_now.tgems>32767) then begin
                 swriteln('');
                 swrite_color('`$Sorry your treasury deposit box can not hold any more gems!`*');
                 exit;end;


                if (amount=1) and (amount+player_now.tgems<32768) then
                 begin
                   swriteln('');
                   swrite_color('`7The Old Man takes `#'+inttostr(player_rec.gem)+' `7Gems for safe keeping...`*');
                   oldman_rec.gems:=oldman_rec.gems+player_rec.gem;
                   player_now.tgems:=player_now.tgems+player_rec.gem;
                   player_rec.gem:=0;
                   end;

                if (amount<=player_rec.gem) and (amount>1) then
                begin
                   swriteln('');
                   swrite_color('`7The Old Man takes `#'+inttostr(amount)+' `7Gems for safe keeping...`*');
                   oldman_rec.gems:=oldman_rec.gems+amount;
                   player_now.tgems:=player_now.tgems+amount;
                   player_rec.gem:=player_rec.gem-amount;
                end;{yes deposit}

           end;{Deposit_Gems}


      end;{Deposit}

       if dw='W' then
       begin
          swrite_color('`!Withdraw`*');swriteln('');
          Swrite_Color('`0`*');
          swrite_color('`0`$$`0`%Gold `*');
          swrite_color('`0`5*`0`%Gems `*');
          Swrite_Color('`0`*');
          swrite_color('`%Option`7:`8> `!');
          repeat sread_char(gg);until gg in ['$','*',#13];

           if gg='$' then
           begin
              swrite_color('`$GOLD`*');swriteln('');

              if (player_now.tgold<1) then
              begin
                 swrite_color('`$There is no gold to transfer!`*');
              exit;
              end;

              swrite_color('`0You have `$'+inttostr(player_now.tgold)+' `0Gold Coins in the Treasury.`*');
              swrite_color('`0How much gold do you want to take`2? `*');
              swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
              sread_num_longint(amount);

              if (amount>player_now.tgold) then
              begin
                 swriteln('');
                 swrite_color('`$There''s not that much gold here!`7 `*');
              end;

              if (amount<1)and(player_now.tgold>0) then swrite_color('`7Okay, nevermind then.`*');

              if (amount+player_rec.gold>2147483646) then begin
                 swriteln('');
                 swrite_color('`$Sorry, you can not carry any more gold!`*');
                 exit;end;

              if (amount=1)and (amount+player_rec.gold<2147483647) then

                 begin
                    swriteln('');
                    swrite_color('`7The Old Man gives you `$'+inttostr(player_now.tgold)+' `7Gold coins.`*');
                    player_rec.gold:=player_rec.gold+player_now.tgold;
                    player_now.tgold:=0;
                 end;{transfer good}

              if (amount<=player_now.tgold) and (amount>1) then
              begin
                 player_rec.gold:=player_rec.gold+amount;
                 player_now.tgold:=player_now.tgold-amount;
                 swriteln('');
                 swrite_color('`7The Old Man gives you `$'+inttostr(amount)+' `7Gold coins.`*');
              end;{yes wd}

           end;{wd_Gold}

           if gg='*' then begin
              swrite_color('`5GEMS`*');swriteln('');

              if (player_now.tgems<1) then begin
                 swrite_color('`$There are no gems to transfer!`*');
                 exit;
                 end;

              swrite_color('`0You have `5'+inttostr(player_now.tgems)+' `0Gems in the Treasury.`*');

              swrite_color('`0How many gems do you want to take`2?`*');
              swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
              sread_num_longint(amount);

                if (amount>player_now.tgems) then begin
                   swriteln('');
                   swrite_color('`$There''s not that many gems here!`7');swriteln('');
                            end;
                if (amount<1) and (player_now.tgems>0) then swrite_color('`7Okay, nevermind then.');swriteln('');

                if (amount+player_rec.gem>32767) then begin
                 swriteln('');
                 swrite_color('`$Sorry, you can not carry any more gems!`*');
                 exit;end;

                if (amount=1) and (amount+player_rec.gem<32768) then
                 begin
                    swriteln('');
                    swrite_color('`7The Old Man gives you `#'+inttostr(player_now.tgems)+' `7Gems.`*');
                    player_rec.gem:=player_rec.gem+player_now.tgems;
                    player_now.tgems:=0;
                 end;{transfer good}


                if (amount<=player_now.tgems) and (amount>1) then begin
                   player_rec.gem:=player_rec.gem+amount;
                   player_now.tgems:=player_now.tgems-amount;
                   swriteln('');
                   swrite_color('`7The Old Man gives you `#'+inttostr(amount)+' `7Gems.`*');
                end;{yes deposit}


           end;{Deposit_Gems}

           end;{Withdraw}

       if dw='T' then

          begin
          swrite_color('`!Transfer`*');

          if dchk=0 then begin
          sclrscr;
          swriteln('');
          Set_Color(1,0);
          swrite_color('`1Ĵ`0Vaulting Via Vulture`1`*');
          Set_Color(15,0);
          swriteln('  The Old Man opens a cage and retrieves an Aging Vulture.');
          set_color(1,0);
          swriteln(      '');
          dchk:=5;
          end;

          swriteln('');
          Set_Color(2,0);swriteln('');
          swrite_color('`0[`%S`0]`7end Gold to Ye Olde Bank`*');
          swrite_color('`0[`%R`0]`7etrieve Gold from Ye Olde Bank`*');
          swrite_color('`0[`%V`0]`7iew Stats`*');
          swrite_color('`2[`7Q`2]`7uit`*');
          Set_Color(2,0);swriteln('');
          set_color(15,0);Swrite('Option');
          set_color(7,0) ;swrite(':> ');
          repeat sread_char(gg);gg:=upcase(gg);until gg in ['S','R','V','Q',#3,#13,'?'];

          if gg in [#13,#3] then sclrscr;
          if gg='?' then swrite_color('`!Display Menu `*');

          if gg='V' then Display_char_stats;

          if gg='Q' then swrite_color('`7Quit `*');

          if gg='S' then begin
              if (player_now.tgold<1) then
              begin
                 swrite_color('`$There is no gold to transfer!`*');
              exit;
              end;

              swrite_color('`0You have `$'+inttostr(player_now.tgold)+' `0Gold Coins in the Treasury.`*');
              swrite_color('`0How much gold do you want to send`2? `*');
              swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
              sread_num_longint(amount);

              if (amount>player_now.tgold) then
              begin
                 swriteln('');
                 swrite_color('`$There''s not that much gold here!`7 `*');
              end;

              if (amount<1)and(player_now.tgold>0) then swrite_color('`7Okay, nevermind then.`*');

              if (amount+player_rec.bank>2147483646) then begin
                 amount:=(2147483646-player_rec.bank);

                 if amount>0 then begin
                 swrite_color('`$Ye Olde Bank can only hold `0'+inttostr(amount)+'`$ more Gold Coins.`*');
                 Swrite_color('`0The Vulture flies out the window carrying the sack of Gold...`*');
                 player_rec.bank:=player_rec.bank+amount;
                 player_now.tgold:=player_now.tgold-amount;
                 swrite_color('`0You still have `$'+inttostr(player_now.tgold)+' `0Gold Coins in the Treasury.`*');
                 end;

                 if amount<1 then
                 swrite_color('`$There is no gold to transfer!`*');

                 exit;end;

              if (amount=1)and (amount+player_rec.bank<2147483647) then

                 begin
                    swriteln('');
                 Swrite_color('`0The Vulture flies out the window carrying the sack of Gold...`*');
                    player_rec.bank:=player_rec.bank+player_now.tgold;
                    player_now.tgold:=0;
                 end;{1 for all}

              if (amount<=player_now.tgold) and (amount>1) then
              begin
                 player_rec.bank:=player_rec.bank+amount;
                 player_now.tgold:=player_now.tgold-amount;
                 swriteln('');
                 Swrite_color('`0The Vulture flies out the window carrying the sack of Gold...`*');
              end;{yes wd}

          end;{S}

          if gg='R' then begin
          if (player_rec.BANK<1) then
              begin
                 swrite_color('`$You have no gold to transfer!`*');
                 exit;
              end;


              if (player_rec.bank>0) then
              begin
                 swrite_color('`0You have `$'+inttostr(player_rec.bank)+' `0Gold Coins in Ye Olde Bank`*');
                 swrite_color('`0How much gold do you want to retrieve`2?`*');
                 swrite_color('`7[`%1 `7for ALL, `%Enter `7to Abort]: `%');
                 sread_num_longint(amount);

                 if (amount>player_rec.bank) then
                  begin
                    swriteln('');
                    swrite_color('`$You do not have that much gold!`7 `*');
                  end;

                 if (amount<1) then swrite_color('`7Okay, nevermind then.`*');
          {xxx---------------------------------------------------xxx}
               if (amount+player_now.tgold>2147483646) then begin
               amount:=(2147483646-player_now.tgold);

                 if amount>0 then begin
                 swrite_color('`$Your Treasury deposit box can only hold `0'+inttostr(amount)+'`$ more Gold Coins.`*');
                 Swrite_color('`0The Vulture flies out the window carrying an empty pouch...`*');
                 player_rec.bank:=player_rec.bank-amount;
                 oldman_rec.gold:=oldman_rec.gold+player_rec.bank;
                 player_now.tgold:=player_now.tgold+amount;
                 swrite_color('`0You still have `$'+inttostr(player_rec.bank)+' `0Gold Coins in Ye Olde Bank.`*');
                 releasetimeslice;delay(300);releasetimeslice;
                 Swrite_color('`2The Vulture flies back through the window and crashes on the floor.`*');
                 swrite_color('`7The Old Man takes `$'+inttostr(amount)+' `7Gold coins for safe keeping...`*');
                 end;

                 if amount<1 then
                 swrite_color('`$There is no gold to transfer!`*');

               exit;end;
          {xxx---------------------------------------------------xxx}
                 if (amount=1) and (amount+player_now.tgold<2147483647) then
                 begin
                    swriteln('');
                    Swrite_color('`0The Vulture flies out the window carrying an empty pouch...`*');
                 releasetimeslice;delay(300);
                 Swrite_color('`2It flies back through the window and crashes on the floor.`*');

                    swrite_color('`7The Old Man takes `$'+inttostr(player_rec.bank)+' `7Gold coins for safe keeping...`*');
                    player_now.tgold:=player_now.tgold+player_rec.bank;
                    oldman_rec.gold:=oldman_rec.gold+player_rec.bank;
                    player_rec.bank:=0;
                 end;{transfer good}

                 if (amount<=player_rec.bank) and (amount>1) then
                 begin
                    swriteln('');
                    Swrite_color('`0The Vulture flies out the window carrying an empty pouch...`*');
                    player_now.tgold:=player_now.tgold+amount;
                    oldman_rec.gold:=oldman_rec.gold+amount;
                    player_rec.bank:=player_rec.bank-amount;
                    swriteln('');
                 releasetimeslice;delay(300);
                 Swrite_color('`2It flies back through the window and crashes on the floor.`*');
                 swrite_color('`7The Old Man takes `$'+inttostr(amount)+' `7Gold coins for safe keeping...`*');
                 end;{transfer good}
             end;
          end;{R}

          end;{DW=T}

   until (upcase(dw)='Q');
end;
{--------------------------------------------------------------------------}
end.